]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blame - make.sh
riscv64: Move libraries back to /usr/lib64
[people/pmueller/ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06fc566a 20# Copyright (C) 2007-2020 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
d12e3fcd 27# If you update the version don't forget to update backupiso and add it to core update
2f767b7b 28VERSION="2.25" # Version number
eb53b56d 29CORE="155" # Core Level (Filename)
e8ee3199
AF
30SLOGAN="www.ipfire.org" # Software slogan
31CONFIG_ROOT=/var/ipfire # Configuration rootdir
e8ee3199 32MAX_RETRIES=1 # prefetch/check loop
305a7b38 33BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 34KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
36e2e992
MT
35
36# Information from Git
37GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
38GIT_TAG="$(git tag | tail -1)" # Git Tag
39GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
628e8c3a 40
cf58f659 41TOOLCHAINVER=20200924
03ad5f93 42
69a6ec55
MT
43###############################################################################
44#
45# Beautifying variables & presentation & input output interface
46#
47###############################################################################
48
f9783277
MT
49# Remember if the shell is interactive or not
50if [ -t 0 ] && [ -t 1 ]; then
51 INTERACTIVE=true
52else
53 INTERACTIVE=false
54fi
55
401a1edc
MT
56# Sets or adjusts pretty formatting variables
57resize_terminal() {
58 ## Screen Dimentions
59 # Find current screen size
60 COLUMNS=$(tput cols)
61
62 # When using remote connections, such as a serial port, stty size returns 0
63 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
64 COLUMNS=80
65 fi
69a6ec55 66
401a1edc
MT
67 # Measurements for positioning result messages
68 OPTIONS_WIDTH=20
69 TIME_WIDTH=12
70 STATUS_WIDTH=8
71 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
72 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
73
e9a57acd
MT
74 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
75 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 76}
69a6ec55 77
401a1edc
MT
78# Initially setup terminal
79resize_terminal
f9783277 80
401a1edc
MT
81# Call resize_terminal when terminal is being resized
82trap "resize_terminal" WINCH
69a6ec55
MT
83
84# Define color for messages
85BOLD="\\033[1;39m"
86DONE="\\033[1;32m"
87SKIP="\\033[1;34m"
88WARN="\\033[1;35m"
89FAIL="\\033[1;31m"
90NORMAL="\\033[0;39m"
91
bcb9dc13 92# New architecture variables
dc7d6b20 93HOST_ARCH="$(uname -m)"
94571564 94
69a6ec55
MT
95PWD=$(pwd)
96BASENAME=$(basename $0)
97
15679d9f
MT
98# Debian specific settings
99if [ ! -e /etc/debian_version ]; then
df5e82b3 100 FULLPATH=`which $0`
15679d9f 101else
df5e82b3
MT
102 if [ -x /usr/bin/realpath ]; then
103 FULLPATH=`/usr/bin/realpath $0`
104 else
105 echo "ERROR: Need to do apt-get install realpath"
106 exit 1
107 fi
15679d9f 108fi
df5e82b3 109
69a6ec55 110# This is the directory where make.sh is in
aecbe123 111export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 112
ebaecf2c
AF
113LOGFILE=$BASEDIR/log/_build.preparation.log
114export LOGFILE
15679d9f 115DIR_CHK=$BASEDIR/cache/check
ebaecf2c 116mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 117
69a6ec55
MT
118system_processors() {
119 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
120}
121
122system_memory() {
123 local key val unit
124
125 while read -r key val unit; do
126 case "${key}" in
127 MemTotal:*)
128 # Convert to MB
129 echo "$(( ${val} / 1024 ))"
130 break
131 ;;
132 esac
133 done < /proc/meminfo
134}
135
136configure_build() {
137 local build_arch="${1}"
138
139 if [ "${build_arch}" = "default" ]; then
140 build_arch="$(configure_build_guess)"
141 fi
142
143 case "${build_arch}" in
144 x86_64)
145 BUILDTARGET="${build_arch}-unknown-linux-gnu"
146 CROSSTARGET="${build_arch}-cross-linux-gnu"
147 BUILD_PLATFORM="x86"
5eec0f21 148 CFLAGS_ARCH="-m64 -mtune=generic -fstack-clash-protection -fcf-protection"
69a6ec55
MT
149 ;;
150
151 i586)
152 BUILDTARGET="${build_arch}-pc-linux-gnu"
153 CROSSTARGET="${build_arch}-cross-linux-gnu"
154 BUILD_PLATFORM="x86"
cf58f659 155 CFLAGS_ARCH="-march=i586 -mtune=generic -fomit-frame-pointer"
69a6ec55
MT
156 ;;
157
158 aarch64)
159 BUILDTARGET="${build_arch}-unknown-linux-gnu"
160 CROSSTARGET="${build_arch}-cross-linux-gnu"
161 BUILD_PLATFORM="arm"
87f3b1e5 162 CFLAGS_ARCH="-fstack-clash-protection"
69a6ec55
MT
163 ;;
164
165 armv7hl)
166 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
167 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
168 BUILD_PLATFORM="arm"
169 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
170 ;;
171
172 armv5tel)
173 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
174 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
175 BUILD_PLATFORM="arm"
176 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
82454983 177 RUSTFLAGS="-Ccodegen-units=1"
69a6ec55
MT
178 ;;
179
161eb15d
MT
180 riscv64)
181 BUILDTARGET="${build_arch}-unknown-linux-gnu"
182 CROSSTARGET="${build_arch}-cross-linux-gnu"
183 BUILD_PLATFORM="riscv"
184 ;;
185
69a6ec55
MT
186 *)
187 exiterror "Cannot build for architure ${build_arch}"
188 ;;
189 esac
190
191 # Check if the QEMU helper is available if needed.
192 if qemu_is_required "${build_arch}"; then
193 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
194
195 if [ -n "${qemu_build_helper}" ]; then
196 QEMU_TARGET_HELPER="${qemu_build_helper}"
197 else
198 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
199 fi
200 fi
201
202 BUILD_ARCH="${build_arch}"
203 TOOLS_DIR="/tools_${BUILD_ARCH}"
204
205 # Enables hardening
54114eb0 206 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
69a6ec55
MT
207
208 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
209 CXXFLAGS="${CFLAGS}"
210
211 # Determine parallelism
eeee108f 212 # We assume that each process consumes about
297473d5 213 # 128MB of memory. Therefore we find out how
eeee108f 214 # many processes fit into memory.
297473d5 215 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
eeee108f
MT
216 local cpu_max=$(( ${SYSTEM_PROCESSORS} + 1 ))
217
218 local parallelism
219 if [ ${mem_max} -lt ${cpu_max} ]; then
220 parallelism=${mem_max}
221 else
222 parallelism=${cpu_max}
69a6ec55 223 fi
212f17c1 224
eeee108f
MT
225 # Use this as default PARALLELISM
226 DEFAULT_PARALLELISM="${parallelism}"
227
e1616eb4
SS
228 # Limit lauched ninja build jobs to computed parallel value.
229 NINJAJOBS="${parallelism}"
230
212f17c1
MT
231 # Compression parameters
232 # We use mode 8 for reasonable memory usage when decompressing
233 # but with overall good compression
234 XZ_OPT="-8"
235
236 # We try to use as many cores as possible
237 XZ_OPT="${XZ_OPT} -T0"
238
239 # We need to limit memory because XZ uses too much when running
240 # in parallel and it isn't very smart in limiting itself.
241 # We allow XZ to use up to 70% of all system memory.
deffc275 242 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
212f17c1
MT
243
244 # XZ memory cannot be larger than 2GB on 32 bit systems
245 case "${build_arch}" in
246 i*86|armv*)
247 if [ ${xz_memory} -gt 2048 ]; then
248 xz_memory=2048
249 fi
250 ;;
251 esac
252
253 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
254}
255
256configure_build_guess() {
257 case "${HOST_ARCH}" in
87487585
MT
258 x86_64)
259 echo "x86_64"
260 ;;
261 i?86)
69a6ec55
MT
262 echo "i586"
263 ;;
264
265 aarch64)
266 echo "aarch64"
267 ;;
268
269 armv7*|armv6*|armv5*)
270 echo "armv5tel"
271 ;;
272
161eb15d
MT
273 riscv64)
274 echo "riscv64"
275 ;;
276
69a6ec55
MT
277 *)
278 exiterror "Cannot guess build architecture"
279 ;;
280 esac
281}
282
f9783277
MT
283stdumount() {
284 umount $BASEDIR/build/sys 2>/dev/null;
285 umount $BASEDIR/build/dev/shm 2>/dev/null;
286 umount $BASEDIR/build/dev/pts 2>/dev/null;
287 umount $BASEDIR/build/dev 2>/dev/null;
288 umount $BASEDIR/build/proc 2>/dev/null;
289 umount $BASEDIR/build/install/mnt 2>/dev/null;
290 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
291 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
292 umount $BASEDIR/build/usr/src/config 2>/dev/null;
293 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
294 umount $BASEDIR/build/usr/src/html 2>/dev/null;
295 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
296 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 297 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277 298 umount $BASEDIR/build/usr/src/src 2>/dev/null;
7c984de6 299 umount $BASEDIR/build/usr/src 2>/dev/null;
cb658c8c 300 umount $BASEDIR/build/tmp 2>/dev/null;
f9783277
MT
301}
302
303now() {
304 date -u "+%s"
69a6ec55
MT
305}
306
f9783277
MT
307format_runtime() {
308 local seconds=${1}
309
310 if [ ${seconds} -ge 3600 ]; then
311 printf "%d:%02d:%02d\n" \
312 "$(( seconds / 3600 ))" \
313 "$(( seconds % 3600 / 60 ))" \
314 "$(( seconds % 3600 % 60 ))"
315 elif [ ${seconds} -ge 60 ]; then
316 printf "%d:%02d\n" \
317 "$(( seconds / 60 ))" \
318 "$(( seconds % 60 ))"
69a6ec55 319 else
f9783277 320 printf "%d\n" "${seconds}"
69a6ec55 321 fi
f9783277 322}
69a6ec55 323
f9783277
MT
324print_line() {
325 local line="$@"
69a6ec55 326
f9783277 327 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
328}
329
f9783277
MT
330_print_line() {
331 local status="${1}"
332 shift
69a6ec55 333
f9783277
MT
334 if ${INTERACTIVE}; then
335 printf "${!status}"
336 fi
69a6ec55 337
f9783277
MT
338 print_line "$@"
339
340 if ${INTERACTIVE}; then
341 printf "${NORMAL}"
342 fi
343}
344
345print_headline() {
346 _print_line BOLD "$@"
69a6ec55
MT
347}
348
f9783277
MT
349print_error() {
350 _print_line FAIL "$@"
351}
352
353print_package() {
354 local name="${1}"
355 shift
69a6ec55 356
f9783277
MT
357 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
358 local options="$@"
359
360 local string="${name}"
361 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
362 string="${string} (${version})"
363 fi
364
365 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 366 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
367}
368
369print_runtime() {
370 local runtime=$(format_runtime $@)
371
372 if ${INTERACTIVE}; then
373 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
374 else
375 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 376 fi
f9783277
MT
377}
378
379print_status() {
380 local status="${1}"
381
382 local color="${!status}"
383
384 if ${INTERACTIVE}; then
385 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
386 else
387 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 388 fi
f9783277 389}
69a6ec55 390
f9783277
MT
391print_build_stage() {
392 print_headline "$@"
393
394 # end line
395 printf "\n"
69a6ec55
MT
396}
397
f9783277
MT
398print_build_summary() {
399 local runtime=$(format_runtime $@)
400
401 print_line "*** Build finished in ${runtime}"
402 print_status DONE
69a6ec55
MT
403}
404
405exiterror() {
406 stdumount
407 for i in `seq 0 7`; do
408 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
409 losetup -d /dev/loop${i} 2>/dev/null
410 fi;
411 done
412
f9783277 413 # Dump logfile
66028310 414 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
415 echo # empty line
416
417 local line
418 while read -r line; do
419 echo " ${line}"
420 done <<< "$(tail -n30 ${LOGFILE})"
421 fi
422
f9783277
MT
423 echo # empty line
424
425 local line
426 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
427 print_error "${line}"
428 print_status FAIL
429 done
430
69a6ec55
MT
431 exit 1
432}
433
aecbe123
MT
434prepareenv() {
435 # Are we running the right shell?
54328605 436 if [ -z "${BASH}" ]; then
aecbe123
MT
437 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
438 fi
439
440 if [ -z "${BASH_VERSION}" ]; then
441 exiterror "Not running BASH shell."
442 fi
443
444 # Trap on emergency exit
445 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
446
aecbe123 447 # Checking if running as root user
658232a6 448 if [ $(id -u) -ne 0 ]; then
df7f30a1 449 exiterror "root privileges required for building"
aecbe123
MT
450 fi
451
452 # Checking for necessary temporary space
f9783277 453 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
454 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
455 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
456 if (( 2048000 > $BASE_ASPACE )); then
457 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
458 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 459 print_status FAIL
aecbe123
MT
460 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
461 fi
462 else
f9783277 463 print_status DONE
aecbe123
MT
464 fi
465
466 # Set umask
467 umask 022
468
469 # Set LFS Directory
470 LFS=$BASEDIR/build
471
aecbe123
MT
472 # Setup environment
473 set +h
474 LC_ALL=POSIX
e1616eb4 475 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
aecbe123
MT
476 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
477
478 # Make some extra directories
479 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
480 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
481 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
3608d485 482 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}} 2>/dev/null
7c984de6
MT
483
484 if [ "${ENABLE_RAMDISK}" = "on" ]; then
485 mkdir -p $BASEDIR/build/usr/src
815ca15d 486 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
ad853b56
MT
487
488 mkdir -p ${BASEDIR}/build/tmp
489 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
7c984de6
MT
490 fi
491
ebaecf2c 492 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
493
494 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
495 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
496
497 # Make all sources and proc available under lfs build
498 mount --bind /dev $BASEDIR/build/dev
499 mount --bind /dev/pts $BASEDIR/build/dev/pts
500 mount --bind /dev/shm $BASEDIR/build/dev/shm
501 mount --bind /proc $BASEDIR/build/proc
502 mount --bind /sys $BASEDIR/build/sys
503 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
3608d485 504 mount --bind $BASEDIR/ccache/${BUILD_ARCH} $BASEDIR/build/usr/src/ccache
aecbe123
MT
505 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
506 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
507 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
508 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
509 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 510 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
511 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
512
513 # Run LFS static binary creation scripts one by one
514 export CCACHE_DIR=$BASEDIR/ccache
36065e42 515 export CCACHE_TEMPDIR="/tmp"
aecbe123
MT
516 export CCACHE_COMPRESS=1
517 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
518
519 # Remove pre-install list of installed files in case user erase some files before rebuild
520 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
521
522 # Prepare string for /etc/system-release.
f48643e5
MT
523 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
524
525 case "${GIT_BRANCH}" in
526 core*|beta?|rc?)
527 system_release="${system_release} - ${GIT_BRANCH}"
528 ;;
529 *)
9ff65bfa 530 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
f48643e5 531 ;;
aecbe123 532 esac
4e54a8e2 533
f48643e5
MT
534 # Append -dirty tag for local changes
535 if [ "$(git status -s | wc -l)" != "0" ]; then
536 system_release="${system_release}-dirty"
537 fi
538
539 # Export variable
540 SYSTEM_RELEASE="${system_release}"
541
040160c7
MT
542 # Decide on PAKFIRE_TREE
543 case "${GIT_BRANCH}" in
544 core*)
545 PAKFIRE_TREE="stable"
546 ;;
547 master)
548 PAKFIRE_TREE="testing"
549 ;;
550 *)
551 PAKFIRE_TREE="unstable"
552 ;;
553 esac
554
4e54a8e2
MT
555 # Setup ccache cache size
556 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
aecbe123
MT
557}
558
69a6ec55
MT
559enterchroot() {
560 # Install QEMU helper, if needed
561 qemu_install_helper
562
563 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
564
565 PATH="${PATH}" chroot ${LFS} env -i \
566 HOME="/root" \
567 TERM="${TERM}" \
568 PS1="${PS1}" \
569 PATH="${PATH}" \
570 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
040160c7 571 PAKFIRE_TREE="${PAKFIRE_TREE}" \
69a6ec55
MT
572 NAME="${NAME}" \
573 SNAME="${SNAME}" \
574 VERSION="${VERSION}" \
575 CORE="${CORE}" \
576 SLOGAN="${SLOGAN}" \
577 TOOLS_DIR="${TOOLS_DIR}" \
578 CONFIG_ROOT="${CONFIG_ROOT}" \
579 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
580 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
82454983 581 RUSTFLAGS="${RUSTFLAGS}" \
69a6ec55
MT
582 BUILDTARGET="${BUILDTARGET}" \
583 CROSSTARGET="${CROSSTARGET}" \
584 BUILD_ARCH="${BUILD_ARCH}" \
585 BUILD_PLATFORM="${BUILD_PLATFORM}" \
586 CCACHE_DIR=/usr/src/ccache \
36065e42 587 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55
MT
588 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
589 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
486112ad 590 GOCACHE="/usr/src/ccache/go" \
69a6ec55 591 KVER="${KVER}" \
0d7a6f03 592 XZ_OPT="${XZ_OPT}" \
77c863a2 593 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
594 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
595 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
596 $(fake_environ) \
597 $(qemu_environ) \
598 "$@"
599}
600
601entershell() {
602 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
603 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
604 fi
605
606 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 607 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
608
609 if enterchroot bash -i; then
610 stdumount
611 else
f9783277 612 print_status FAIL
69a6ec55
MT
613 exiterror "chroot error"
614 fi
615}
616
617lfsmakecommoncheck() {
618 # Script present?
619 if [ ! -f $BASEDIR/lfs/$1 ]; then
620 exiterror "No such file or directory: $BASEDIR/$1"
621 fi
622
f9783277
MT
623 # Print package name and version
624 print_package $@
69a6ec55
MT
625
626 # Check if this package is supported by our architecture.
627 # If no SUP_ARCH is found, we assume the package can be built for all.
628 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
629 # Check if package supports ${BUILD_ARCH} or all architectures.
630 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 631 print_runtime 0
f9783277 632 print_status SKIP
69a6ec55
MT
633 return 1
634 fi
635 fi
636
637 # Script slipped?
638 local i
639 for i in $SKIP_PACKAGE_LIST
640 do
641 if [ "$i" == "$1" ]; then
f9783277 642 print_status SKIP
69a6ec55
MT
643 return 1;
644 fi
645 done
646
647 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
648
649 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
650 MESSAGE="$1\t " download >> $LOGFILE 2>&1
651 if [ $? -ne 0 ]; then
652 exiterror "Download error in $1"
653 fi
654
655 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
656 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
657 if [ $? -ne 0 ]; then
658 exiterror "md5sum error in $1, check file in cache or signature"
659 fi
660
661 return 0 # pass all!
662}
663
664lfsmake1() {
665 lfsmakecommoncheck $*
666 [ $? == 1 ] && return 0
667
69a6ec55
MT
668 cd $BASEDIR/lfs && env -i \
669 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
670 CCACHE_DIR="${CCACHE_DIR}" \
36065e42 671 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55
MT
672 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
673 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
674 CFLAGS="${CFLAGS}" \
675 CXXFLAGS="${CXXFLAGS}" \
77c863a2 676 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
677 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
678 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
679 make -f $* \
680 TOOLCHAIN=1 \
681 TOOLS_DIR="${TOOLS_DIR}" \
682 CROSSTARGET="${CROSSTARGET}" \
683 BUILDTARGET="${BUILDTARGET}" \
684 BUILD_ARCH="${BUILD_ARCH}" \
685 BUILD_PLATFORM="${BUILD_PLATFORM}" \
686 LFS_BASEDIR="${BASEDIR}" \
687 ROOT="${LFS}" \
688 KVER="${KVER}" \
f9783277 689 install >> $LOGFILE 2>&1 &
69a6ec55 690
f9783277
MT
691 if ! wait_until_finished $!; then
692 print_status FAIL
693 exiterror "Building $*"
69a6ec55
MT
694 fi
695
f9783277 696 print_status DONE
69a6ec55
MT
697}
698
699lfsmake2() {
700 lfsmakecommoncheck $*
701 [ $? == 1 ] && return 0
702
69a6ec55
MT
703 local PS1='\u:\w$ '
704
705 enterchroot \
ce9264a1 706 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
707 make -f $* \
708 LFS_BASEDIR=/usr/src install" \
f9783277 709 >> ${LOGFILE} 2>&1 &
69a6ec55 710
f9783277
MT
711 if ! wait_until_finished $!; then
712 print_status FAIL
713 exiterror "Building $*"
69a6ec55
MT
714 fi
715
f9783277 716 print_status DONE
69a6ec55
MT
717}
718
719ipfiredist() {
720 lfsmakecommoncheck $*
721 [ $? == 1 ] && return 0
722
69a6ec55
MT
723 local PS1='\u:\w$ '
724
725 enterchroot \
726 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 727 >> ${LOGFILE} 2>&1 &
69a6ec55 728
f9783277
MT
729 if ! wait_until_finished $!; then
730 print_status FAIL
731 exiterror "Packaging $*"
732 fi
69a6ec55 733
f9783277
MT
734 print_status DONE
735}
736
737wait_until_finished() {
738 local pid=${1}
739
740 local start_time=$(now)
741
742 # Show progress
743 if ${INTERACTIVE}; then
744 # Wait a little just in case the process
745 # has finished very quickly.
746 sleep 0.1
747
748 local runtime
749 while kill -0 ${pid} 2>/dev/null; do
750 print_runtime $(( $(now) - ${start_time} ))
751
752 # Wait a little
753 sleep 1
754 done
69a6ec55 755 fi
f9783277
MT
756
757 # Returns the exit code of the child process
758 wait ${pid}
759 local ret=$?
760
761 if ! ${INTERACTIVE}; then
762 print_runtime $(( $(now) - ${start_time} ))
763 fi
764
765 return ${ret}
69a6ec55
MT
766}
767
768fake_environ() {
769 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
770
771 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
772
773 # Fake kernel version, because some of the packages do not compile
774 # with kernel 3.0 and later.
8634797e 775 env="${env} UTS_RELEASE=${KVER}-ipfire"
69a6ec55
MT
776
777 # Fake machine version.
778 env="${env} UTS_MACHINE=${BUILD_ARCH}"
779
780 echo "${env}"
781}
782
783qemu_environ() {
784 local env
785
786 # Don't add anything if qemu is not used.
787 if ! qemu_is_required; then
788 return
789 fi
790
791 # Set default qemu options
792 case "${BUILD_ARCH}" in
793 arm*)
794 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
795
796 env="${env} QEMU_CPU=${QEMU_CPU}"
797 ;;
798 esac
799
800 # Enable QEMU strace
801 #env="${env} QEMU_STRACE=1"
802
803 echo "${env}"
804}
805
806qemu_is_required() {
807 local build_arch="${1}"
808
809 if [ -z "${build_arch}" ]; then
810 build_arch="${BUILD_ARCH}"
811 fi
812
813 case "${HOST_ARCH},${build_arch}" in
161eb15d 814 x86_64,arm*|x86_64,aarch64|x86_64,riscv64|i?86,arm*|i?86,aarch64|i?86,x86_64)
69a6ec55
MT
815 return 0
816 ;;
817 *)
818 return 1
819 ;;
820 esac
821}
822
823qemu_install_helper() {
824 # Do nothing, if qemu is not required
825 if ! qemu_is_required; then
826 return 0
827 fi
828
829 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
830 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
831 fi
832
833 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
834 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
835 fi
836
837
838 if [ -z "${QEMU_TARGET_HELPER}" ]; then
839 exiterror "QEMU_TARGET_HELPER not set"
840 fi
841
842 # Check if the helper is already installed.
843 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
844 return 0
845 fi
846
847 # Try to find a suitable binary that we can install
848 # to the build environment.
849 local file
850 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
851 # file must exist and be executable.
852 [ -x "${file}" ] || continue
853
854 # Must be static.
855 file_is_static "${file}" || continue
856
857 local dirname="${LFS}$(dirname "${file}")"
858 mkdir -p "${dirname}"
859
860 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
861 return 0
862 done
863
864 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
865}
866
867qemu_find_build_helper_name() {
868 local build_arch="${1}"
869
870 local magic
871 case "${build_arch}" in
0db0f7fa
AF
872 aarch64)
873 magic="7f454c460201010000000000000000000200b700"
874 ;;
4576ca4c
MT
875 arm*)
876 magic="7f454c4601010100000000000000000002002800"
877 ;;
161eb15d
MT
878 riscv64)
879 magic="7f454c460201010000000000000000000200f300"
880 ;;
69a6ec55
MT
881 x86_64)
882 magic="7f454c4602010100000000000000000002003e00"
883 ;;
884 esac
885
886 [ -z "${magic}" ] && return 1
887
888 local file
889 for file in /proc/sys/fs/binfmt_misc/*; do
890 # skip write only register entry
891 [ $(basename "${file}") = "register" ] && continue
892 # Search for the file with the correct magic value.
893 grep -qE "^magic ${magic}$" "${file}" || continue
894
895 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
896
897 [ -n "${interpreter}" ] || continue
898 [ "${interpreter:0:1}" = "/" ] || continue
899 [ -x "${interpreter}" ] || continue
900
901 echo "${interpreter}"
902 return 0
903 done
904
905 return 1
906}
907
908file_is_static() {
909 local file="${1}"
910
911 file ${file} 2>/dev/null | grep -q "statically linked"
912}
913
914update_language_list() {
915 local path="${1}"
916
917 local lang
918 for lang in ${path}/*.po; do
919 lang="$(basename "${lang}")"
920 echo "${lang%*.po}"
921 done | sort -u > "${path}/LINGUAS"
922}
923
1fb7f56e
MT
924contributors() {
925 local commits name
926
927 git shortlog --summary --numbered | while read -r commits name; do
928 echo "${name}"
929 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
930}
931
932update_contributors() {
933 echo -n "Updating list of contributors"
934
935 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
936
937 # Edit contributors into credits.cgi
e2338aa7
MT
938 local tmp="$(mktemp)"
939
940 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
941 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
942
943 # Copy back modified content
944 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
945 unlink "${tmp}"
1fb7f56e
MT
946
947 print_status DONE
948 return 0
949}
950
15b005d8 951# Default settings
99597de7 952CCACHE_CACHE_SIZE="4G"
15b005d8
MT
953ENABLE_RAMDISK="auto"
954
a98ab1d7
MT
955# Load configuration file
956if [ -f .config ]; then
957 . .config
958fi
959
813659f2
MT
960# TARGET_ARCH is BUILD_ARCH now
961if [ -n "${TARGET_ARCH}" ]; then
962 BUILD_ARCH="${TARGET_ARCH}"
963 unset TARGET_ARCH
964fi
965
85560933
MT
966# Get some information about the host system
967SYSTEM_PROCESSORS="$(system_processors)"
968SYSTEM_MEMORY="$(system_memory)"
969
dc7d6b20
MT
970if [ -n "${BUILD_ARCH}" ]; then
971 configure_build "${BUILD_ARCH}"
949544f5 972else
dc7d6b20 973 configure_build "default"
949544f5
MT
974fi
975
15b005d8
MT
976# Automatically enable/disable ramdisk usage
977if [ "${ENABLE_RAMDISK}" = "auto" ]; then
978 # Enable only when the host system has 4GB of RAM or more
979 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
980 ENABLE_RAMDISK="on"
981 fi
982fi
983
df5e82b3 984buildtoolchain() {
69a6ec55
MT
985 local error=false
986 case "${BUILD_ARCH}:${HOST_ARCH}" in
987 # x86_64
988 x86_64:x86_64)
989 # This is working.
990 ;;
991
992 # x86
993 i586:i586|i586:i686|i586:x86_64)
994 # These are working.
995 ;;
996 i586:*)
997 error=true
998 ;;
999
1000 # ARM
1001 arvm7hl:armv7hl|armv7hl:armv7l)
1002 # These are working.
1003 ;;
1004
1005 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
1006 # These are working.
1007 ;;
1008 armv5tel:*)
1009 error=true
1010 ;;
1011 esac
1012
1013 ${error} && \
1014 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
1015
1016 local gcc=$(type -p gcc)
1017 if [ -z "${gcc}" ]; then
1018 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1019 fi
1020
6bd3a131
MT
1021 # Check ${TOOLS_DIR} symlink
1022 if [ -h "${TOOLS_DIR}" ]; then
1023 rm -f "${TOOLS_DIR}"
1024 fi
1025
1026 if [ ! -e "${TOOLS_DIR}" ]; then
1027 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1028 fi
1029
1030 if [ ! -h "${TOOLS_DIR}" ]; then
1031 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1032 fi
1033
ebaecf2c 1034 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
1035 export LOGFILE
1036
1037 lfsmake1 stage1
1038 lfsmake1 ccache PASS=1
1039 lfsmake1 binutils PASS=1
1040 lfsmake1 gcc PASS=1
1041 lfsmake1 linux KCFG="-headers"
1042 lfsmake1 glibc
178c7a6a 1043 lfsmake1 libxcrypt
69a6ec55
MT
1044 lfsmake1 gcc PASS=L
1045 lfsmake1 binutils PASS=2
1046 lfsmake1 gcc PASS=2
54d54148 1047 lfsmake1 zlib
69a6ec55
MT
1048 lfsmake1 ccache PASS=2
1049 lfsmake1 tcl
1050 lfsmake1 expect
1051 lfsmake1 dejagnu
1052 lfsmake1 pkg-config
1053 lfsmake1 ncurses
1054 lfsmake1 bash
1055 lfsmake1 bzip2
1056 lfsmake1 automake
1057 lfsmake1 coreutils
1058 lfsmake1 diffutils
1059 lfsmake1 findutils
1060 lfsmake1 gawk
1061 lfsmake1 gettext
1062 lfsmake1 grep
1063 lfsmake1 gzip
1064 lfsmake1 m4
1065 lfsmake1 make
1066 lfsmake1 patch
1067 lfsmake1 perl
46bbc13b 1068 lfsmake1 python3
69a6ec55
MT
1069 lfsmake1 sed
1070 lfsmake1 tar
1071 lfsmake1 texinfo
1072 lfsmake1 xz
85439ac7 1073 lfsmake1 bison
11b5e5cb 1074 lfsmake1 flex
69a6ec55 1075 lfsmake1 fake-environ
7b93b62b 1076 lfsmake1 strip
69a6ec55 1077 lfsmake1 cleanup-toolchain
df5e82b3
MT
1078}
1079
1080buildbase() {
ebaecf2c 1081 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1082 export LOGFILE
1083 lfsmake2 stage2
1084 lfsmake2 linux KCFG="-headers"
1085 lfsmake2 man-pages
1086 lfsmake2 glibc
1087 lfsmake2 tzdata
1088 lfsmake2 cleanup-toolchain
1089 lfsmake2 zlib
b14c24ca 1090 lfsmake2 zstd
cf6c8e67
MT
1091 lfsmake2 autoconf
1092 lfsmake2 automake
1093 lfsmake2 libtool
69a6ec55
MT
1094 lfsmake2 binutils
1095 lfsmake2 gmp
69a6ec55
MT
1096 lfsmake2 mpfr
1097 lfsmake2 libmpc
cf6c8e67 1098 lfsmake2 libxcrypt
69a6ec55
MT
1099 lfsmake2 file
1100 lfsmake2 gcc
1101 lfsmake2 sed
69a6ec55
MT
1102 lfsmake2 berkeley
1103 lfsmake2 coreutils
1104 lfsmake2 iana-etc
1105 lfsmake2 m4
1106 lfsmake2 bison
69a6ec55 1107 lfsmake2 ncurses
69a6ec55
MT
1108 lfsmake2 perl
1109 lfsmake2 readline
69a6ec55 1110 lfsmake2 bzip2
3ece7859 1111 lfsmake2 xz
f407f05a 1112 lfsmake2 lzip
69a6ec55 1113 lfsmake2 pcre
b0c37190 1114 lfsmake2 pcre2
d701756a 1115 lfsmake2 gettext
241bf919
MT
1116 lfsmake2 attr
1117 lfsmake2 acl
69a6ec55
MT
1118 lfsmake2 bash
1119 lfsmake2 diffutils
69a6ec55
MT
1120 lfsmake2 ed
1121 lfsmake2 findutils
1122 lfsmake2 flex
1123 lfsmake2 gawk
d2315d00 1124 lfsmake2 go
69a6ec55
MT
1125 lfsmake2 grep
1126 lfsmake2 groff
1127 lfsmake2 gperf
1128 lfsmake2 gzip
1129 lfsmake2 hostname
1130 lfsmake2 iproute2
1131 lfsmake2 jwhois
1132 lfsmake2 kbd
1133 lfsmake2 less
4720fa0d 1134 lfsmake2 pkg-config
50992c73 1135 lfsmake2 procps
69a6ec55
MT
1136 lfsmake2 make
1137 lfsmake2 man
69a6ec55
MT
1138 lfsmake2 net-tools
1139 lfsmake2 patch
1140 lfsmake2 psmisc
1141 lfsmake2 shadow
1142 lfsmake2 sysklogd
1143 lfsmake2 sysvinit
1144 lfsmake2 tar
1145 lfsmake2 texinfo
1146 lfsmake2 util-linux
69a6ec55 1147 lfsmake2 vim
69b3d63b 1148 lfsmake2 e2fsprogs
df5e82b3
MT
1149}
1150
15679d9f 1151buildipfire() {
ebaecf2c 1152 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1153 export LOGFILE
489145db
MT
1154 lfsmake2 configroot
1155 lfsmake2 initscripts
1156 lfsmake2 backup
c38f55fe 1157 lfsmake2 openssl
1ece41ec 1158 lfsmake2 kmod
e1c6cd05 1159 lfsmake2 udev
3755e358 1160 lfsmake2 popt
d4767896 1161 lfsmake2 libedit
489145db
MT
1162 lfsmake2 libusb
1163 lfsmake2 libusb-compat
1164 lfsmake2 libpcap
1165 lfsmake2 ppp
1166 lfsmake2 pptp
1167 lfsmake2 unzip
1168 lfsmake2 which
1169 lfsmake2 linux-firmware
489145db 1170 lfsmake2 dvb-firmwares
37b86fa9 1171 lfsmake2 xr819-firmware
489145db
MT
1172 lfsmake2 zd1211-firmware
1173 lfsmake2 rpi-firmware
26796f3a 1174 lfsmake2 intel-microcode
0e54ca26 1175 lfsmake2 pcengines-apu-firmware
489145db 1176 lfsmake2 bc
2a0947f2 1177 lfsmake2 u-boot MKIMAGE=1
489145db
MT
1178 lfsmake2 cpio
1179 lfsmake2 mdadm
1180 lfsmake2 dracut
de18b4de 1181 lfsmake2 libaio
489145db
MT
1182 lfsmake2 lvm2
1183 lfsmake2 multipath-tools
1184 lfsmake2 freetype
489145db
MT
1185 lfsmake2 libmnl
1186 lfsmake2 libnfnetlink
1187 lfsmake2 libnetfilter_queue
1188 lfsmake2 libnetfilter_conntrack
1189 lfsmake2 libnetfilter_cthelper
1190 lfsmake2 libnetfilter_cttimeout
1191 lfsmake2 iptables
0245f3b6 1192 lfsmake2 screen
54ead8ef 1193 lfsmake2 elfutils
8e6fb99d 1194
dc7d6b20 1195 case "${BUILD_ARCH}" in
68a36e26 1196 x86_64|aarch64)
489145db 1197 lfsmake2 linux KCFG=""
b389d731
AF
1198# lfsmake2 backports KCFG=""
1199# lfsmake2 e1000e KCFG=""
1200# lfsmake2 igb KCFG=""
1201# lfsmake2 ixgbe KCFG=""
489145db
MT
1202 lfsmake2 xtables-addons KCFG=""
1203 lfsmake2 linux-initrd KCFG=""
fc155193 1204 ;;
3d02c091 1205 i586)
3d02c091 1206 # x86 kernel build
489145db 1207 lfsmake2 linux KCFG=""
b389d731
AF
1208# lfsmake2 backports KCFG=""
1209# lfsmake2 e1000e KCFG=""
1210# lfsmake2 igb KCFG=""
1211# lfsmake2 ixgbe KCFG=""
489145db
MT
1212 lfsmake2 xtables-addons KCFG=""
1213 lfsmake2 linux-initrd KCFG=""
3d02c091 1214 ;;
544f40d4 1215
3d02c091 1216 armv5tel)
3d02c091 1217 # arm multi platform (Panda, Wandboard ...) kernel build
489145db 1218 lfsmake2 linux KCFG="-multi"
0a21d63f
AF
1219# lfsmake2 backports KCFG="-multi"
1220# lfsmake2 e1000e KCFG="-multi"
1221# lfsmake2 igb KCFG="-multi"
1222# lfsmake2 ixgbe KCFG="-multi"
489145db
MT
1223 lfsmake2 xtables-addons KCFG="-multi"
1224 lfsmake2 linux-initrd KCFG="-multi"
3d02c091
MT
1225 ;;
1226 esac
489145db 1227 lfsmake2 xtables-addons USPACE="1"
489145db
MT
1228 lfsmake2 libgpg-error
1229 lfsmake2 libgcrypt
1230 lfsmake2 libassuan
1231 lfsmake2 nettle
1a7db134 1232 lfsmake2 json-c
f3e62301 1233 lfsmake2 libconfig
489145db
MT
1234 lfsmake2 libevent
1235 lfsmake2 libevent2
1236 lfsmake2 expat
c8e9a7a8
WA
1237 lfsmake2 apr
1238 lfsmake2 aprutil
489145db
MT
1239 lfsmake2 unbound
1240 lfsmake2 gnutls
1241 lfsmake2 bind
1242 lfsmake2 dhcp
1243 lfsmake2 dhcpcd
1244 lfsmake2 boost
1245 lfsmake2 linux-atm
1246 lfsmake2 gdbm
1247 lfsmake2 pam
d44ce7d4 1248 lfsmake2 c-ares
489145db
MT
1249 lfsmake2 curl
1250 lfsmake2 tcl
1251 lfsmake2 sqlite
1252 lfsmake2 libffi
1253 lfsmake2 python
1254 lfsmake2 python3
8a4495a4 1255 lfsmake2 gdb
b3ce3510
MT
1256 lfsmake2 grub
1257 lfsmake2 efivar
1258 lfsmake2 efibootmgr
489145db
MT
1259 lfsmake2 ca-certificates
1260 lfsmake2 fireinfo
1261 lfsmake2 libnet
1262 lfsmake2 libnl
1263 lfsmake2 libnl-3
1264 lfsmake2 libidn
1265 lfsmake2 nasm
4f516b87
MF
1266 lfsmake2 libarchive
1267 lfsmake2 cmake
814a33ff
SS
1268 lfsmake2 ninja
1269 lfsmake2 meson
489145db 1270 lfsmake2 libjpeg
58d965fe 1271 lfsmake2 openjpeg
489145db
MT
1272 lfsmake2 libexif
1273 lfsmake2 libpng
1274 lfsmake2 libtiff
1275 lfsmake2 libart
1276 lfsmake2 gd
489145db
MT
1277 lfsmake2 slang
1278 lfsmake2 newt
1279 lfsmake2 libsmooth
489145db 1280 lfsmake2 libcap
b051eb68 1281 lfsmake2 libcap-ng
489145db
MT
1282 lfsmake2 pciutils
1283 lfsmake2 usbutils
1284 lfsmake2 libxml2
1285 lfsmake2 libxslt
1286 lfsmake2 BerkeleyDB
489145db
MT
1287 lfsmake2 cyrus-sasl
1288 lfsmake2 openldap
1289 lfsmake2 apache2
489145db
MT
1290 lfsmake2 web-user-interface
1291 lfsmake2 flag-icons
1292 lfsmake2 jquery
6033b271 1293 lfsmake2 bootstrap
489145db
MT
1294 lfsmake2 arping
1295 lfsmake2 beep
1df47cc9 1296 lfsmake2 libssh
8a960584 1297 lfsmake2 cdrkit
489145db
MT
1298 lfsmake2 dosfstools
1299 lfsmake2 reiserfsprogs
1300 lfsmake2 xfsprogs
1301 lfsmake2 sysfsutils
1302 lfsmake2 fuse
1303 lfsmake2 ntfs-3g
1304 lfsmake2 ethtool
489145db
MT
1305 lfsmake2 fcron
1306 lfsmake2 perl-GD
1307 lfsmake2 GD-Graph
1308 lfsmake2 GD-TextUtil
1309 lfsmake2 perl-Device-SerialPort
1310 lfsmake2 perl-Device-Modem
1311 lfsmake2 perl-Apache-Htpasswd
bbcaca56 1312 lfsmake2 perl-Parse-Yapp
489145db
MT
1313 lfsmake2 gnupg
1314 lfsmake2 hdparm
1315 lfsmake2 sdparm
1316 lfsmake2 mtools
1317 lfsmake2 whatmask
29370584 1318 lfsmake2 libtirpc
489145db
MT
1319 lfsmake2 conntrack-tools
1320 lfsmake2 libupnp
1321 lfsmake2 ipaddr
1322 lfsmake2 iputils
1323 lfsmake2 l7-protocols
489145db
MT
1324 lfsmake2 hwdata
1325 lfsmake2 logrotate
1326 lfsmake2 logwatch
1327 lfsmake2 misc-progs
1328 lfsmake2 nano
1329 lfsmake2 URI
294aa009
AF
1330 lfsmake2 perl-CGI
1331 lfsmake2 perl-Switch
489145db
MT
1332 lfsmake2 HTML-Tagset
1333 lfsmake2 HTML-Parser
1334 lfsmake2 HTML-Template
1335 lfsmake2 Compress-Zlib
1336 lfsmake2 Digest
1337 lfsmake2 Digest-SHA1
1338 lfsmake2 Digest-HMAC
1339 lfsmake2 libwww-perl
1340 lfsmake2 Net-DNS
1341 lfsmake2 Net-IPv4Addr
1342 lfsmake2 Net_SSLeay
1343 lfsmake2 IO-Stringy
1344 lfsmake2 IO-Socket-SSL
1345 lfsmake2 Unix-Syslog
1346 lfsmake2 Mail-Tools
1347 lfsmake2 MIME-Tools
1348 lfsmake2 Net-Server
1349 lfsmake2 Convert-TNEF
1350 lfsmake2 Convert-UUlib
1351 lfsmake2 Archive-Tar
1352 lfsmake2 Archive-Zip
1353 lfsmake2 Text-Tabs+Wrap
489145db
MT
1354 lfsmake2 XML-Parser
1355 lfsmake2 Crypt-PasswdMD5
1356 lfsmake2 Net-Telnet
1357 lfsmake2 python-setuptools
1358 lfsmake2 python-clientform
1359 lfsmake2 python-mechanize
1360 lfsmake2 python-feedparser
1361 lfsmake2 python-rssdler
1362 lfsmake2 python-inotify
1363 lfsmake2 python-docutils
1364 lfsmake2 python-daemon
1365 lfsmake2 python-ipaddress
1366 lfsmake2 glib
489145db
MT
1367 lfsmake2 ntp
1368 lfsmake2 openssh
1369 lfsmake2 fontconfig
1370 lfsmake2 dejavu-fonts-ttf
70f6cba4 1371 lfsmake2 ubuntu-font-family
489145db
MT
1372 lfsmake2 freefont
1373 lfsmake2 pixman
1374 lfsmake2 cairo
1375 lfsmake2 pango
1376 lfsmake2 rrdtool
489145db
MT
1377 lfsmake2 setup
1378 lfsmake2 libdnet
59fe9735 1379 lfsmake2 rust
616395f3 1380 lfsmake2 jansson
91cc908f 1381 lfsmake2 yaml
3498300d 1382 lfsmake2 libhtp
1a5f0649 1383 lfsmake2 colm
2348cfff 1384 lfsmake2 ragel
52ebc66b 1385 lfsmake2 hyperscan
67752a95 1386 lfsmake2 suricata
489145db 1387 lfsmake2 oinkmaster
ef640882 1388 lfsmake2 ids-ruleset-sources
489145db
MT
1389 lfsmake2 squid
1390 lfsmake2 squidguard
1391 lfsmake2 calamaris
1392 lfsmake2 tcpdump
1393 lfsmake2 traceroute
1394 lfsmake2 vlan
1395 lfsmake2 wireless
1396 lfsmake2 pakfire
1397 lfsmake2 spandsp
adf3f4f4 1398 lfsmake2 lz4
489145db
MT
1399 lfsmake2 lzo
1400 lfsmake2 openvpn
489145db
MT
1401 lfsmake2 mpage
1402 lfsmake2 dbus
1403 lfsmake2 intltool
1404 lfsmake2 libdaemon
6064cd87 1405 lfsmake2 avahi
489145db 1406 lfsmake2 cups
489145db 1407 lfsmake2 lcms2
56170c2a 1408 lfsmake2 ghostscript
489145db
MT
1409 lfsmake2 qpdf
1410 lfsmake2 poppler
d3dabd4b 1411 lfsmake2 poppler-data
489145db
MT
1412 lfsmake2 cups-filters
1413 lfsmake2 epson-inkjet-printer-escpr
1414 lfsmake2 foomatic
1415 lfsmake2 hplip
1416 lfsmake2 cifs-utils
1417 lfsmake2 krb5
95849177 1418 lfsmake2 rpcsvc-proto
489145db 1419 lfsmake2 samba
18d000c4 1420 lfsmake2 netatalk
489145db
MT
1421 lfsmake2 sudo
1422 lfsmake2 mc
1423 lfsmake2 wget
1424 lfsmake2 bridge-utils
489145db
MT
1425 lfsmake2 smartmontools
1426 lfsmake2 htop
1427 lfsmake2 chkconfig
1428 lfsmake2 postfix
1429 lfsmake2 fetchmail
489145db 1430 lfsmake2 clamav
294aa009 1431 lfsmake2 perl-NetAddr-IP
489145db
MT
1432 lfsmake2 dma
1433 lfsmake2 alsa
1434 lfsmake2 mpfire
1435 lfsmake2 guardian
1436 lfsmake2 libid3tag
1437 lfsmake2 libmad
1438 lfsmake2 libogg
1439 lfsmake2 libvorbis
1440 lfsmake2 libdvbpsi
1441 lfsmake2 flac
1442 lfsmake2 lame
1443 lfsmake2 sox
41f8d642 1444 lfsmake2 soxr
489145db
MT
1445 lfsmake2 libshout
1446 lfsmake2 xvid
1447 lfsmake2 libmpeg2
489145db
MT
1448 lfsmake2 gnump3d
1449 lfsmake2 rsync
489145db 1450 lfsmake2 rpcbind
14fb55a5 1451 lfsmake2 keyutils
8af744bc 1452 lfsmake2 libnfsidmap
489145db
MT
1453 lfsmake2 nfs
1454 lfsmake2 gnu-netcat
1455 lfsmake2 ncat
1456 lfsmake2 nmap
489145db
MT
1457 lfsmake2 etherwake
1458 lfsmake2 bwm-ng
1459 lfsmake2 sysstat
489145db
MT
1460 lfsmake2 strongswan
1461 lfsmake2 rng-tools
1462 lfsmake2 lsof
1463 lfsmake2 br2684ctl
1464 lfsmake2 pcmciautils
1465 lfsmake2 lm_sensors
1466 lfsmake2 liboping
1467 lfsmake2 collectd
1468 lfsmake2 elinks
1469 lfsmake2 igmpproxy
1470 lfsmake2 fbset
1471 lfsmake2 opus
1472 lfsmake2 python-six
1473 lfsmake2 python-pyparsing
1474 lfsmake2 spice-protocol
1475 lfsmake2 spice
1476 lfsmake2 sdl
1477 lfsmake2 libusbredir
43c3a386 1478 lfsmake2 libseccomp
489145db
MT
1479 lfsmake2 qemu
1480 lfsmake2 sane
1481 lfsmake2 netpbm
489145db 1482 lfsmake2 netsnmpd
489145db 1483 lfsmake2 nagios_nrpe
2af354c2 1484 lfsmake2 nagios-plugins
489145db 1485 lfsmake2 icinga
01c2ea6b 1486 lfsmake2 observium-agent
489145db 1487 lfsmake2 ebtables
489145db 1488 lfsmake2 faad2
e91ceed6 1489 lfsmake2 alac
489145db
MT
1490 lfsmake2 ffmpeg
1491 lfsmake2 vdr
1492 lfsmake2 vdr_streamdev
489145db
MT
1493 lfsmake2 vdr_epgsearch
1494 lfsmake2 vdr_dvbapi
1495 lfsmake2 vdr_eepg
1496 lfsmake2 w_scan
489145db
MT
1497 lfsmake2 mpd
1498 lfsmake2 libmpdclient
1499 lfsmake2 mpc
985741db 1500 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1501 lfsmake2 perl-Net-SMTP-SSL
1502 lfsmake2 perl-MIME-Base64
1503 lfsmake2 perl-Authen-SASL
1504 lfsmake2 perl-MIME-Lite
1505 lfsmake2 perl-Email-Date-Format
1506 lfsmake2 git
1507 lfsmake2 squidclamav
1508 lfsmake2 vnstat
1509 lfsmake2 iw
1510 lfsmake2 wpa_supplicant
1511 lfsmake2 hostapd
1512 lfsmake2 pycurl
1513 lfsmake2 urlgrabber
1514 lfsmake2 syslinux
1515 lfsmake2 tftpd
1516 lfsmake2 cpufrequtils
489145db
MT
1517 lfsmake2 gutenprint
1518 lfsmake2 apcupsd
67fbd255 1519 lfsmake2 fireperf
489145db
MT
1520 lfsmake2 iperf
1521 lfsmake2 iperf3
1522 lfsmake2 7zip
1523 lfsmake2 lynis
489145db
MT
1524 lfsmake2 sshfs
1525 lfsmake2 taglib
489145db
MT
1526 lfsmake2 sslh
1527 lfsmake2 perl-gettext
1528 lfsmake2 perl-Sort-Naturally
1529 lfsmake2 vdradmin
489145db 1530 lfsmake2 perl-DBI
489145db
MT
1531 lfsmake2 perl-DBD-SQLite
1532 lfsmake2 perl-File-ReadBackwards
489145db 1533 lfsmake2 openvmtools
5d92a00e 1534 lfsmake2 libmicrohttpd
489145db
MT
1535 lfsmake2 motion
1536 lfsmake2 joe
1537 lfsmake2 monit
1538 lfsmake2 nut
1539 lfsmake2 watchdog
1540 lfsmake2 libpri
1541 lfsmake2 libsrtp
1542 lfsmake2 asterisk
489145db
MT
1543 lfsmake2 usb_modeswitch
1544 lfsmake2 usb_modeswitch_data
1545 lfsmake2 zerofree
489145db
MT
1546 lfsmake2 minicom
1547 lfsmake2 ddrescue
489145db
MT
1548 lfsmake2 miniupnpd
1549 lfsmake2 client175
1550 lfsmake2 powertop
1551 lfsmake2 parted
1552 lfsmake2 swig
2a0947f2 1553 lfsmake2 u-boot
6836e528 1554 lfsmake2 u-boot-friendlyarm
5c82a9f0 1555 lfsmake2 python-typing
489145db
MT
1556 lfsmake2 python-m2crypto
1557 lfsmake2 wireless-regdb
1558 lfsmake2 crda
1559 lfsmake2 libsolv
1560 lfsmake2 python-distutils-extra
1561 lfsmake2 python-lzma
1562 lfsmake2 python-progressbar
489145db 1563 lfsmake2 ddns
2d17377a 1564 lfsmake2 python3-setuptools
662b2a81 1565 lfsmake2 python3-setuptools-scm
9e25fe5c 1566 lfsmake2 python3-six
e0a05a80 1567 lfsmake2 python3-dateutil
d48ea6b5 1568 lfsmake2 python3-jmespath
a33ca4cc 1569 lfsmake2 python3-colorama
041d2116 1570 lfsmake2 python3-docutils
d2da17a1 1571 lfsmake2 python3-yaml
953f6f73 1572 lfsmake2 python3-s3transfer
d45d5247 1573 lfsmake2 python3-rsa
faa5472a 1574 lfsmake2 python3-pyasn1
05be1c64 1575 lfsmake2 python3-urllib3
4ab80c5d 1576 lfsmake2 python3-botocore
3be81987 1577 lfsmake2 python3-llfuse
def9f4a3 1578 lfsmake2 python3-msgpack
280ee7e7 1579 lfsmake2 aws-cli
489145db
MT
1580 lfsmake2 transmission
1581 lfsmake2 dpfhack
1582 lfsmake2 lcd4linux
1583 lfsmake2 mtr
489145db
MT
1584 lfsmake2 minidlna
1585 lfsmake2 acpid
1586 lfsmake2 fping
1587 lfsmake2 telnet
1588 lfsmake2 xinetd
1589 lfsmake2 gpgme
1590 lfsmake2 pygpgme
1591 lfsmake2 pakfire3
1592 lfsmake2 stress
1593 lfsmake2 libstatgrab
1594 lfsmake2 sarg
489145db
MT
1595 lfsmake2 nginx
1596 lfsmake2 sendEmail
1597 lfsmake2 sysbench
1598 lfsmake2 strace
489145db
MT
1599 lfsmake2 ltrace
1600 lfsmake2 ipfire-netboot
1601 lfsmake2 lcdproc
489145db
MT
1602 lfsmake2 keepalived
1603 lfsmake2 ipvsadm
1604 lfsmake2 perl-Carp-Clan
1605 lfsmake2 perl-Date-Calc
1606 lfsmake2 perl-Date-Manip
1607 lfsmake2 perl-File-Tail
1608 lfsmake2 perl-TimeDate
1609 lfsmake2 swatch
1610 lfsmake2 tor
489145db
MT
1611 lfsmake2 wavemon
1612 lfsmake2 iptraf-ng
1613 lfsmake2 iotop
1614 lfsmake2 stunnel
489145db 1615 lfsmake2 bacula
b62c826f
MT
1616 lfsmake2 perl-Font-TTF
1617 lfsmake2 perl-IO-String
489145db
MT
1618 lfsmake2 perl-PDF-API2
1619 lfsmake2 squid-accounting
1620 lfsmake2 pigz
1621 lfsmake2 tmux
1622 lfsmake2 perl-Text-CSV_XS
09b09b85 1623 lfsmake2 lua
489145db
MT
1624 lfsmake2 haproxy
1625 lfsmake2 ipset
489145db
MT
1626 lfsmake2 dnsdist
1627 lfsmake2 bird
1a7db134 1628 lfsmake2 frr
489145db
MT
1629 lfsmake2 dmidecode
1630 lfsmake2 mcelog
489145db
MT
1631 lfsmake2 util-macros
1632 lfsmake2 libpciaccess
1633 lfsmake2 libyajl
1634 lfsmake2 libvirt
42fca290 1635 lfsmake2 libtalloc
489145db
MT
1636 lfsmake2 freeradius
1637 lfsmake2 perl-common-sense
1638 lfsmake2 perl-inotify2
1639 lfsmake2 perl-Net-IP
0d6cc79d 1640 lfsmake2 wio
773caa66 1641 lfsmake2 iftop
ddcd60f7 1642 lfsmake2 mdns-repeater
429af178 1643 lfsmake2 i2c-tools
4e9000b4 1644 lfsmake2 nss-myhostname
014b235a 1645 lfsmake2 dehydrated
c708fa15 1646 lfsmake2 shairport-sync
46114d79 1647 lfsmake2 borgbackup
50483167 1648 lfsmake2 lmdb
2397e513 1649 lfsmake2 knot
e1982c69 1650 lfsmake2 spectre-meltdown-checker
06fc6170 1651 lfsmake2 zabbix_agentd
82d176d3 1652 lfsmake2 flashrom
2aca6aa0 1653 lfsmake2 firmware-update
ffcef39d 1654 lfsmake2 tshark
9875e9f2 1655 lfsmake2 speedtest-cli
0db643ce 1656 lfsmake2 rfkill
44cc9a3d 1657 lfsmake2 amazon-ssm-agent
d938509e 1658 lfsmake2 libloc
4d275bcd 1659 lfsmake2 ncdu
76c5f3e0 1660 lfsmake2 lshw
68fbcc0e 1661 lfsmake2 socat
d0817963 1662}
df5e82b3
MT
1663
1664buildinstaller() {
1665 # Run installer scripts one by one
ebaecf2c 1666 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1667 export LOGFILE
489145db
MT
1668 lfsmake2 memtest
1669 lfsmake2 installer
ce9264a1
AF
1670 # use toolchain bash for chroot to strip
1671 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1672}
1673
1674buildpackages() {
ebaecf2c 1675 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1676 export LOGFILE
1677 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1678
df5e82b3
MT
1679
1680 # Generating list of packages used
dc4ae0b7 1681 print_line "Generating packages list from logs"
df5e82b3 1682 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1683 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1684 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1685 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1686 fi
1687 done
7471f6ab 1688 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1689 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1690 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1691 rm -f $BASEDIR/doc/packages-list
c9673262 1692 # packages-list.txt is ready to be displayed for wiki page
f9783277 1693 print_status DONE
4b06f504
MT
1694
1695 # Update changelog
e49f7f0d 1696 cd $BASEDIR
c43b07fd
AF
1697 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1698 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1699 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1700
9607771a 1701 # Create images for install
489145db 1702 lfsmake2 cdrom
bada0832 1703
4dc82852 1704 # Check if there is a loop device for building in virtual environments
841663e7
MT
1705 modprobe loop 2>/dev/null
1706 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1707 lfsmake2 flash-images
4dc82852 1708 fi
c9673262 1709
c4dd9dfc 1710 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1711
0d909a4a 1712 ipfirepackages
e67a57fe 1713
b307417f 1714 cd $BASEDIR
744a04ea
AF
1715
1716 # remove not useable iso on armv5tel (needed to build flash images)
dc7d6b20 1717 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
744a04ea 1718
5336aaa6 1719 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
b307417f
AF
1720 md5sum $i > $i.md5
1721 done
1722 cd $PWD
1723
e67a57fe
MT
1724 # Cleanup
1725 stdumount
1726 rm -rf $BASEDIR/build/tmp/*
1727
e67a57fe 1728 cd $PWD
e67a57fe
MT
1729}
1730
1731ipfirepackages() {
489145db 1732 lfsmake2 core-updates
5596077b
MT
1733
1734 local i
dc7d6b20 1735 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1736 i=$(basename ${i})
453b418b
MT
1737 if [ -e $BASEDIR/lfs/$i ]; then
1738 ipfiredist $i
1739 else
1740 echo -n $i
f9783277 1741 print_status SKIP
453b418b 1742 fi
fe7fe395 1743 done
78331e30 1744 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1745 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1746 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1747}
1748
bcb9dc13
MT
1749while [ $# -gt 0 ]; do
1750 case "${1}" in
1751 --target=*)
c2e810de 1752 configure_build "${1#--target=}"
bcb9dc13
MT
1753 ;;
1754 -*)
1755 exiterror "Unknown configuration option: ${1}"
1756 ;;
1757 *)
1758 # Found a command, so exit options parsing.
1759 break
1760 ;;
1761 esac
1762 shift
1763done
1764
df5e82b3
MT
1765# See what we're supposed to do
1766case "$1" in
1767build)
f9783277
MT
1768 START_TIME=$(now)
1769
1770 # Clear screen
1771 ${INTERACTIVE} && clear
1772
f74072a2 1773 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
df5e82b3 1774 #only restore on a clean disk
6c4cc7ea 1775 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1776 if [ ! -n "$PACKAGE" ]; then
f9783277 1777 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1778 prepareenv
1779 buildtoolchain
1780 else
f74072a2 1781 PACKAGENAME=${PACKAGE%.tar.xz}
f9783277 1782 print_build_stage "Packaged toolchain compilation"
df5e82b3 1783 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
f74072a2 1784 tar axf $PACKAGE
df5e82b3
MT
1785 prepareenv
1786 else
1787 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1788 fi
1789 fi
1790 else
df5e82b3
MT
1791 prepareenv
1792 fi
5cfe86e6 1793
f9783277 1794 print_build_stage "Building LFS"
df5e82b3 1795 buildbase
15679d9f 1796
f9783277 1797 print_build_stage "Building IPFire"
15679d9f 1798 buildipfire
5cfe86e6 1799
f9783277 1800 print_build_stage "Building installer"
df5e82b3 1801 buildinstaller
15679d9f 1802
f9783277 1803 print_build_stage "Building packages"
df5e82b3 1804 buildpackages
7a5ed24e 1805
f9783277 1806 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1807
1808 cd $BASEDIR
7a5ed24e 1809 tools/checknewlog.pl
e0c923f4 1810 tools/checkrootfiles
b307417f 1811 cd $PWD
a23731d1 1812
f9783277 1813 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1814 ;;
1815shell)
1816 # enter a shell inside LFS chroot
1817 # may be used to changed kernel settings
1818 prepareenv
1819 entershell
1820 ;;
df5e82b3 1821clean)
f9783277
MT
1822 print_line "Cleaning build directory..."
1823
df5e82b3
MT
1824 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1825 $LOSETUP -d $i 2>/dev/null
1826 done
b0c37190
MT
1827 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1828 # umount $i
1829 #done
df5e82b3
MT
1830 stdumount
1831 for i in `seq 0 7`; do
69a6ec55 1832 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1833 umount /dev/loop${i} 2>/dev/null;
1834 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1835 fi;
df5e82b3
MT
1836 done
1837 rm -rf $BASEDIR/build
1838 rm -rf $BASEDIR/cdrom
f9315063 1839 rm -rf $BASEDIR/packages
ebaecf2c 1840 rm -rf $BASEDIR/log
6c4cc7ea
MT
1841 if [ -h "${TOOLS_DIR}" ]; then
1842 rm -f "${TOOLS_DIR}"
df5e82b3 1843 fi
b307417f 1844 rm -f $BASEDIR/ipfire-*
f9783277 1845 print_status DONE
df5e82b3 1846 ;;
4e432799
MT
1847docker)
1848 # Build the docker image if it does not exist, yet
1849 if ! docker images -a | grep -q ^ipfire-builder; then
1850 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1851 print_status DONE
1852 else
1853 print_status FAIL
1854 exit 1
1855 fi
1856 fi
1857
1858 # Run the container and enter a shell
1859 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1860 ;;
c3db995c 1861downloadsrc)
df5e82b3
MT
1862 if [ ! -d $BASEDIR/cache ]; then
1863 mkdir $BASEDIR/cache
1864 fi
ebaecf2c 1865 mkdir -p $BASEDIR/log
857d9bf2 1866 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1867 FINISHED=0
1868 cd $BASEDIR/lfs
1869 for c in `seq $MAX_RETRIES`; do
1870 if (( FINISHED==1 )); then
1871 break
1872 fi
1873 FINISHED=1
1874 cd $BASEDIR/lfs
1875 for i in *; do
1876 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1877 lfsmakecommoncheck ${i} || continue
1878
dc7d6b20 1879 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1880 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1881 if [ $? -ne 0 ]; then
f9783277 1882 print_status FAIL
df5e82b3
MT
1883 FINISHED=0
1884 else
1885 if [ $c -eq 1 ]; then
f9783277 1886 print_status DONE
df5e82b3
MT
1887 fi
1888 fi
1889 fi
1890 done
1891 done
e22c7973 1892 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1893 ERROR=0
1894 for i in *; do
1895 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1896 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1897 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1898 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1899 if [ $? -ne 0 ]; then
e22c7973 1900 echo -ne "MD5 difference in lfs/$i"
f9783277 1901 print_status FAIL
df5e82b3
MT
1902 ERROR=1
1903 fi
1904 fi
1905 done
1906 if [ $ERROR -eq 0 ]; then
e22c7973 1907 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1908 print_status DONE
e22c7973
MT
1909 else
1910 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1911 print_status FAIL
df5e82b3 1912 fi
e22c7973 1913 cd - >/dev/null 2>&1
df5e82b3 1914 ;;
df5e82b3 1915toolchain)
f9783277
MT
1916 # Clear screen
1917 ${INTERACTIVE} && clear
1918
df5e82b3 1919 prepareenv
f3b7cf47 1920 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1921 buildtoolchain
f74072a2 1922 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1923 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
ebaecf2c 1924 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
b46f951e 1925 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
f74072a2 1926 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
dc7d6b20 1927 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1928 stdumount
1929 ;;
1930gettoolchain)
df5e82b3 1931 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1932 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
f74072a2 1933 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
5bd13f01 1934 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1935 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1936 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1937 cd $BASEDIR/cache/toolchains
f74072a2 1938 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1939 if [ $? -ne 0 ]; then
dc7d6b20 1940 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1941 else
f74072a2 1942 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1943 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1944 else
1945 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1946 fi
40a4ea4c 1947 fi
712d859c
MT
1948 else
1949 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1950 fi
1951 ;;
15679d9f
MT
1952uploadsrc)
1953 PWD=`pwd`
661d9388
CS
1954 if [ -z $IPFIRE_USER ]; then
1955 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1956 print_status FAIL
661d9388
CS
1957 exit 1
1958 fi
ae23a606 1959
661d9388 1960 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
15e38431 1961 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
661d9388 1962
15e38431
MT
1963 for file in ${BASEDIR}/cache/*; do
1964 [ -d "${file}" ] && continue
1965 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
661d9388 1966 NEW_FILES="$NEW_FILES $file"
0eab8e84 1967 done
661d9388
CS
1968 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1969 cd $BASEDIR
15679d9f
MT
1970 cd $PWD
1971 exit 0
0eab8e84 1972 ;;
bf7c473f 1973lang)
69a6ec55
MT
1974 echo -ne "Checking the translations for missing or obsolete strings..."
1975 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1976 $BASEDIR/tools/sort_strings.pl en
1977 $BASEDIR/tools/sort_strings.pl de
1978 $BASEDIR/tools/sort_strings.pl fr
1979 $BASEDIR/tools/sort_strings.pl es
1980 $BASEDIR/tools/sort_strings.pl pl
1981 $BASEDIR/tools/sort_strings.pl ru
1982 $BASEDIR/tools/sort_strings.pl nl
1983 $BASEDIR/tools/sort_strings.pl tr
1984 $BASEDIR/tools/sort_strings.pl it
1985 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1986 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1987 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1988 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
72c8478e 1989 $BASEDIR/tools/check_strings.pl pl > $BASEDIR/doc/language_issues.pl
69a6ec55
MT
1990 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1991 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1992 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1993 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1994 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1995 print_status DONE
69a6ec55
MT
1996
1997 echo -ne "Updating language lists..."
1998 update_language_list ${BASEDIR}/src/installer/po
1999 update_language_list ${BASEDIR}/src/setup/po
f9783277 2000 print_status DONE
bf7c473f 2001 ;;
1fb7f56e
MT
2002update-contributors)
2003 update_contributors
2004 ;;
ba137dd8
MT
2005find-dependencies)
2006 shift
2007 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
2008 ;;
6b8cff41 2009*)
ba137dd8 2010 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies}"
6b8cff41
MT
2011 cat doc/make.sh-usage
2012 ;;
3ea75603 2013esac
98329972 2014